/*
 * File:   ECE167_Main.c
 * Author: dahh2
 *
 * Created on April 14, 2021, 1:54 PM
 */


#include "xc.h"
#include "sys/attribs.h"
#include "stdio.h"
#include "stdlib.h"
#include "BOARD.h"
#include "serial.h"
#include "AD.h"
#include "Oled.h"
#include "pwm.h"
#include "ToneGeneration.h"
#include "I2C.h"
#include "ICM20948.h"
#include "timers.h"
#include "stdint.h"
#include "MatrixMath.h"
#include "Lab_4_functions.h"
#include "GenericTypeDefs.h"

void InputString( unsigned char string[]);


#define LEDS_SET(leds) do { LATE = (leds); } while (0)//LED set function
static char o[128];
static int count =0;
static int t =0;
static int i;
float Accavg[3][500];
float Magavg[3][500];
float Gyroavg[3][500];
float AcShifts[3] = {-0.0052, -0.0080,0.0131};
float MgShifts[3] = {0.0812,0.1187,0.4717};
float GyShifts[3] = {0,0,0};
float AcGains[3] = {0.9977,0.9982,1.0108};
float MgGains[3] = {1,1,1};
float GyGains[3] = {1,1,1};
float R[3][3]={{1,0,0},{0,1,0},{0,0,1}};
float B[3]={0,0,0};
float dT = 0.02;
float GScale = (M_PI/(131*180));
float Ascale = (1.0/16384.0);
float Mscale= (0.15);
float Magfram[3][3]={{0.8995,0.3872,0.2026},{-0.4118,0.9062,0.0964},{-0.1463,-0.1701,0.9745}};
static int Start = 0;
int main(void)
{
    //init functions
    BOARD_Init();
    SERIAL_Init();
    OledInit();
    TIMERS_Init();
    ICM20948_Init();
    //pins for inputs and outputs on I/O shield
    TRISE = 0x000;//LEDS
    unsigned char Hello[]= "Hello World \n";
    InputString(Hello);
while(1){
        LEDS_SET(1);
        if(TIMERS_GetMilliSeconds()>t){
            LEDS_SET(2);
            t+=20;
            float Ax= ((float)ICM20948_ReadAccelX()+85.0147)*Ascale;
            float Ay= ((float)ICM20948_ReadAccelY()+131.2688)*Ascale;
            float Az= ((float)ICM20948_ReadAccelZ()-214.2337)*Ascale;
            float Mx= ((float)ICM20948_ReadMagX()-135)*(Mscale); ///299
            float My= ((float)ICM20948_ReadMagY()+141)*(Mscale); ///247
            float Mz= ((float)ICM20948_ReadMagZ()-65)*(Mscale); ///302
            float Gx= (float)ICM20948_ReadGyroX();
            float Gy= (float)ICM20948_ReadGyroY();
            float Gz= (float)ICM20948_ReadGyroZ();
            //HARD CODED TEST VALUES
            
            float Acc[3]= {Ax,Ay,Az};
            float Mag[3]= {Mx,My,Mz};
            float Gyro[3]= {Gx,Gy,Gz};
//            printf("%+06f,%+06f,%+06f,%+06f,%+06f,%+06f,%+06f,%+06f,%+06f \r\n", Acc[0], Acc[1], Acc[2],Mag[0], Mag[1], Mag[2],Gyro[0], Gyro[1], Gyro[2]);
            //keeps track of average for first second
//            printf("Data:\nA[%f,%f,%f]\n",Ax,Ay,Az);
//            printf("M[%f,%f,%f]\n",Mx,My,Mz);
//            printf("G[%f,%f,%f]\n",Gx,Gy,Gz);
            if(!Start){
//                Accavg[0][count]=Ax;
//                Accavg[1][count]=Ay;
//                Accavg[2][count]=Az;
//                Magavg[0][count]=Mx;
//                Magavg[1][count]=My;
//                Magavg[2][count]=Mz;
                Gyroavg[0][count]=Gx;
                Gyroavg[1][count]=Gy;
                Gyroavg[2][count]=Gz;
                sprintf(o,"biasing!! \n DO NOT MOVE\n %d",(500-count)/50);//converts to a char
                OledClear(0);//clears old values 0 for setting all to black
                OledDrawString(o);//sets new string to be printed
                OledUpdate();//updated OLED
//                printf("M[%f,%f,%f]\n",Magavg[0][count],Magavg[1][count],Magavg[2][count]);
                count++;
            }
            if(count>=500 && !Start){
                Start = 1;
//                printf("Avgs:\nA[%f,%f,%f]\n",Accavg[0][0],Accavg[1][0],Accavg[2][0]);
//                printf("M[%f,%f,%f]\n",Magavg[0][0],Magavg[1][0],Magavg[2][0]);
//                printf("G[%f,%f,%f]\n",Gyroavg[0][0],Gyroavg[1][0],Gyroavg[2][0]);
//                Bias(Accavg, AcShifts,AcGains);
//                printf("Acc:\nA[%f,%f,%f]\n",Accavg[0][0],Accavg[1][0],Accavg[2][0]);
//                printf("shifts:\nA[%f,%f,%f]\n",AcShifts[0],AcShifts[1],AcShifts[]);
//                Bias(Magavg, MgShifts,MgGains);
//                GyroBias(Gyroavg, GyShifts);
//                printf("Shifts:\nA[%f,%f,%f]\n",AcShifts[0],AcShifts[1],AcShifts[2]);
//                printf("M[%f,%f,%f]\n",MgShifts[0],MgShifts[1],MgShifts[2]);
//                printf("G[%f,%f,%f]\n",GyShifts[0],GyShifts[1],GyShifts[2]);
//                printf("Gains:\nA[%f,%f,%f]\n",AcGains[0],AcGains[1],AcGains[2]);
//                printf("M[%f,%f,%f]\n",MgGains[0],MgGains[1],MgGains[2]);
            }
            if(Start){
//                LEDS_SET(4);
//                Scale(Acc,AcShifts,AcGains);
//                Scale(Mag,MgShifts,MgGains);
                Scale(Gyro,GyShifts,GyGains);
                ScalerMult3x1(Gyro,GScale,Gyro);
                MatrixMult3x1(Mag,Magfram,Mag);
                float Euler[3] = {0,0,0};
//                IntOpen(R, Gyro, dT);
//                printf("%+06f,%+06f,%+06f,%+06f,%+06f,%+06f,%+06f,%+06f,%+06f \r\n", Acc[0], Acc[1], Acc[2],Mag[0], Mag[1], Mag[2],Gyro[0], Gyro[1], Gyro[2]);
                IntClosed(R,B,Gyro,Mag,Acc,dT);
//                printf("%+06f,%+06f,%+06f,%+06f,%+06f,%+06f,%+06f,%+06f,%+06f \r\n", Acc[0], Acc[1], Acc[2],Mag[0], Mag[1], Mag[2],Gyro[0], Gyro[1], Gyro[2]);
//                printf("R=\n[%f,%f,%f]\n[%f,%f,%f]\n[%f,%f,%f]\n",R[0][0],R[0][1],R[0][2],R[1][0],R[1][1],R[1][2],R[2][0],R[2][1],R[2][2]);
                float TR[3][3];
                float TEul[3];
                Triad(TR,Mag,Acc);
                dmc2Euler(R,Euler);
                dmc2Euler(TR,TEul);
//                printf("RT=\n[%f,%f,%f]\n[%f,%f,%f]\n[%f,%f,%f]\n",TR[0][0],TR[0][1],TR[0][2],TR[1][0],TR[1][1],TR[1][2],TR[2][0],TR[2][1],TR[2][2]);
                printf("%+06f,%+06f,%+06f,%+06f,%+06f,%+06f, \r\n", Euler[0],Euler[1],Euler[2],TEul[0],TEul[1],TEul[2]);
                sprintf(o,"yaw:%.2f \npitch:%.2f  \nroll:%.2f  \n",Euler[0],Euler[1],Euler[2]);//converts to a char
                
                OledClear(0);//clears old values 0 for setting all to black
                OledDrawString(o);//sets new string to be printed
                OledUpdate();//updated OLED
            }
           
        }
    }
        
    BOARD_End();
    return 1;
}
void InputString( unsigned char string[]){ //inputs sting into the buffer.
    int i;
    for(i =0; string[i] !=0; i++){
        PutChar(string[i]);
    }
    return;
}