/* MatrixMath.c
 Dylan Harootunian
 ECE167
 Contains Functions for manipulating matrices
 Specificly relating too euler angles*/
#include "MatrixMath.h"


void dmc2Euler(float DCM[3][3], float Eulers[3]){
//    if (DCM[0][2] > 1) DCM[0][2] = 1;
//    if (DCM[0][2] < -1) DCM[0][2] = -1;
    Eulers[0]= atan2(DCM[0][1], DCM[0][0])*(180/M_PI);    //yaw
    Eulers[1]= -(asin(DCM[0][2]))*(180/M_PI);             //pitch
    Eulers[2]= (atan2(DCM[1][2], DCM[2][2]))*(180/M_PI);  //roll
    return;
}

void Euler2DCM(float Eulers[3], float DCM[3][3]){
    float D[3][3]= {{cosf(Eulers[0]),   sinf(Eulers[0]), 0},
                    {-sinf(Eulers[0]),  cosf(Eulers[0]), 0},
                    {0,                 0,              1}};
    
    float C[3][3]= {{cosf(Eulers[1]),   0,  -sinf(Eulers[1])},
                    {0,                 1,  0},
                    {sinf(Eulers[1]),   0,  cosf(Eulers[1])}};
    
    float M[3][3]= {{1,                 0,                  0},
                    {0,                 cosf(Eulers[2]),    sinf(Eulers[2])},
                    {0,                 -sinf(Eulers[2]),   cosf(Eulers[2])}};
    float temp[3][3];
    MatrixMult3x3(M,C,temp);
    MatrixMult3x3(temp,D,DCM);
    return;
}

void ScewGen(float pqr[3],float W[3][3]){
    W[0][0]=0;
    W[0][1]=-pqr[2];
    W[0][2]=pqr[1];
    W[1][0]=pqr[2];
    W[1][1]=0;
    W[1][2]=-pqr[0];
    W[2][0]=-pqr[1];
    W[2][1]=pqr[0];
    W[2][2]=0;
    return;
}


float Hypot3(float w[3]){
    float H = w[0]*w[0]+w[1]*w[1]+w[2]*w[2];
    return H;
}
float Hypot32(float w[3]){
    float H = sqrt(w[0]*w[0]+w[1]*w[1]+w[2]*w[2]);
    return H;
}

void MatrixAdd3x1(float M1[3],float M2[3],float MR[3]){
    int i;
//    printf("Adding Matices [%f,%f,%f]+[%f,%f,%f]\n",M1[0],M1[1],M1[2],M2[0],M2[1],M2[2]);
    for(i=0;i<(3);i++){
        MR[i]=(M1[i]+M2[i]);
    }
    return;
}

void MatrixSub3x1(float M1[3],float M2[3],float MR[3]){
    int i;
//    printf("Subtracting Matices [%f,%f,%f]-[%f,%f,%f]\n",M1[0],M1[1],M1[2],M2[0],M2[1],M2[2]);
    for(i=0;i<(3);i++){
        MR[i]=(M1[i]-M2[i]);
    }
    return;
}

void MatrixAdd3x3(float M1[3][3],float M2[3][3],float MR[3][3]){
    int i,j;
    for (i = 0; i < 3; i++)
    {
        for (j = 0; j < 3; j++)
        {
            MR[i][j] = M1[i][j] + M2[i][j];
        }
    }
    return;
}

void MatrixSub3x3(float M1[3][3],float M2[3][3],float MR[3][3]){
    int i,j;
    for (i = 0; i < 3; i++){
        for (j = 0; j < 3; j++){
            MR[i][j] = M1[i][j] - M2[i][j];
        }
    }
    return;
}

void ScalerMult3x1(float M1[3],float Scale,float MR[3]){
    int i;
    for(i=0;i<3;i++){
        MR[i]=M1[i]*Scale;
    }
    return;
}

void ScalerMult3x3(float M1[3][3],float Scale,float MR[3][3]){
    int i,j;
    for (i = 0; i < 3; i++) {
        for (j = 0; j < 3; j++){
            MR[i][j]=M1[i][j]*Scale;
        }
    }
    return;
}

void MatrixMult3x1(float M1[3],float M2[3][3],float MR[3]){
    int i;
    float temp[3];
    for(i=0;i<3;i++){
        temp[i]=(M1[0]*M2[i][0])+(M1[1]*M2[i][1])+(M1[2]*M2[i][2]);
    }
    for(i=0;i<3;i++){
        MR[i]=temp[i];
    }
    return;
}

void MatrixMult3x3(float M1[3][3],float M2[3][3],float MR[3][3]){
    int i,j;
    float temp[3][3];
    for(i=0;i<3;i++){
        for(j=0;j<3;j++){
            temp[i][j]=(M1[i][0]*M2[0][j])+(M1[i][1]*M2[1][j])+(M1[i][2]*M2[2][j]);
        }
    }
    for(i=0;i<3;i++){
        for(j=0;j<3;j++){
            MR[i][j]=temp[i][j];
        }
    }
    return;
}

//void MatrixTranspose3x1(float M1[3],float M2[3],float MR[3]){
//    
//}

void MatrixTranspose3x3(float M1[3][3],float MR[3][3]){
    int i,j;
    float temp[3][3];
    for(i=0;i<3;i++){
        for(j=0;j<3;j++){
            temp[i][j]=M1[j][i];
        }
    }
    for(i=0;i<3;i++){
        for(j=0;j<3;j++){
            MR[i][j]=temp[i][j];
        }
    }
    return;
}