clear;
clear all;
close all;

accelInertial=[0;0;1];
accelReading=[0;0;1];
magInertial=[22.825;5.393;41.690];
magReading=[11;-15;1];


clear;
clear all;
close all;

D2R=(pi/180);
Mscale = 1;
Ascale = 1;
R=eye(3);
dT=1/50;
w=[0,0,0];
Rexp(w,dT);
[Acc,Mag,wGyro,Eul] = CreateTrajectoryData(dT,0);
Mo = [22825;5393;41690]/1000;
Ao = [0;0;1];
GyroSec = wGyro((1:50),:);
Nullshift = mean(GyroSec);
Gyro = wGyro-Nullshift;
B = [0;0;0];
G=transpose((Gyro/131)*D2R);%scaling Gyro
M= transpose(Mag.*Mscale);
A= transpose((Acc/Ascale));%scaling Accel
%R = eul2dcm(Eul(1,1:3));
%R= eye(3);
E= zeros(length(Eul), 3);
for i=1:length(wGyro)
    [R1,B1] = IntegrateClosedLoop(R,B,G(:,i),M(:,i),A(:,i),Mo,Ao,dT);
    E(i,:) = [atan2(R1(1,2),R1(1,1)), real(-asin(R1(1,3))), atan2(R1(2,3),R1(3,3))]*180/pi;
    R=R1;
    R2 = DCMfromTriad(M(:,i),A(:,i),Mo,Ao)
    Eul(i,:) = [atan2(R2(1,2),R2(1,1)), real(-asin(R2(1,3))), atan2(R2(2,3),R2(3,3))]*180/pi;
end

plt = dT*[0:length(Gyro)-1];
%Yaw is Z so it is in coloum 3
figure(1);
subplot(3,1,1)
plot(plt,E(:,1))
hold
title('yaw Triad vs Closed loop')
plot(plt,Eul(:,1))


subplot(3,1,2)
plot(plt,E(:,2))
hold
title('pitch Triad vs Closed loop')
plot(plt,Eul(:,2))

% 
subplot(3,1,3)
plot(plt,E(:,3))
hold
title('roll Triad vs Closed loop')
plot(plt,Eul(:,3))


function R=eul2dcm(eul)
%----------------------------------------------------------------
% function C=eul2dcm(eul)
%
%   This functions determines the direction cosine matrix C
%   that transforms a vector in a reference axis system at time k
%   to one the same axis sytem at time k+1.  The input argument to
%   this function is a vector of the Euler angles in the following
%   order: eul = [yaw,pitch,roll]. (i.e., 3-2-1 rotation convention).  
%
%-----------------------------------------------------------------  

ps=eul(1); th=eul(2); ph=eul(3);

C1=[1 0 0; 0 cosd(ph) sind(ph); 0 -sind(ph) cosd(ph)];
C2=[cosd(th) 0 -sind(th); 0 1 0; sind(th) 0 cosd(th)];
C3=[cosd(ps) sind(ps) 0; -sind(ps) cosd(ps) 0; 0 0 1];

R=C1*C2*C3;
end