clear;
clear all;
close all;


dT=1/50;
w=[0,0,0];
Rexp(w,dT);
[Acc,Mag,wGyro,Eul] = CreateTrajectoryData(dT,0);
%R = eul2dcm(Eul(1,1:3));
%R= eye(3);
E= zeros(length(Eul), 3);
for i=1:length(wGyro)
    R1= IntegrateOpenLoop(R,(transpose((wGyro(i,1:3)/131)*pi/180)),dT);
    E(i,:) = [atan2(R1(1,2),R1(1,1)), real(-asin(R1(1,3))), atan2(R1(2,3),R1(3,3))]*180/pi;
    R=R1;
end


plt = dT*[0:length(wGyro)-1];

figure(1);
title('No Noise')
subplot(3,1,1)
plot(plt,Eul(:,1))
title('Clean yaw')
hold on
plot(plt,E(:,1))

subplot(3,1,2)
plot(plt,Eul(:,2))
title('Clean pitch')
hold on
plot(plt,E(:,2))

subplot(3,1,3)
plot(plt,Eul(:,3))
title('Clean roll')
hold on
plot(plt,E(:,3))
hold off

%Noisy DATA

[Acc,Mag,wGyro,Eul] = CreateTrajectoryData(dT,1);
GyroSec = wGyro((1:50),:);
Nullshift = mean(GyroSec)
Gyro = wGyro-Nullshift;
R = eul2dcm(Eul(1,1:3));
% R=eye(3);
E= zeros(length(Eul), 3);
for i=1:length(Gyro)
    R1= IntegrateOpenLoop(R,(transpose((Gyro(i,1:3)/131)*pi/180)),dT);
    E(i,:) = [atan2(R1(1,2),R1(1,1)), real(-asin(R1(1,3))), atan2(R1(2,3),R1(3,3))]*180/pi;
    R=R1;
end


plt = dT*[0:length(Gyro)-1];

figure(2);
subplot(3,1,1)
plot(plt,Eul(:,1))
title('Noisy yaw')
hold on
plot(plt,E(:,1))

subplot(3,1,2)
plot(plt,Eul(:,2))
title('Noisy pitch')
hold on
plot(plt,E(:,2))

subplot(3,1,3)
plot(plt,Eul(:,3))
title('Noisy roll')
hold on
plot(plt,E(:,3))
hold off


function R=eul2dcm(eul)
%----------------------------------------------------------------
% function C=eul2dcm(eul)
%
%   This functions determines the direction cosine matrix C
%   that transforms a vector in a reference axis system at time k
%   to one the same axis sytem at time k+1.  The input argument to
%   this function is a vector of the Euler angles in the following
%   order: eul = [yaw,pitch,roll]. (i.e., 3-2-1 rotation convention).  
%
%-----------------------------------------------------------------  

ps=eul(1); th=eul(2); ph=eul(3);

C1=[1 0 0; 0 cosd(ph) sind(ph); 0 -sind(ph) cosd(ph)];
C2=[cosd(th) 0 -sind(th); 0 1 0; sind(th) 0 cosd(th)];
C3=[cosd(ps) sind(ps) 0; -sind(ps) cosd(ps) 0; 0 0 1];

R=C1*C2*C3;
end